////////////////////////////////////////////////////////
//                                                    //
// bzTag.cpp -- this file contains definitions of tag //
//           structure and interface for operations   // 
// ver 1.01                                           //  
//                                                    //   
// Language: standard C++                             // 
// Platform: Linux Debian                             //
// Contact:  Minmei Hou, PhD Candidate                //  
//           CSE Dept., Penn State University         //
//           mhou@cse.psu.edu                         //    
////////////////////////////////////////////////////////


#ifndef BZTAG_HPP
#define BZTAG_HPP
#include <iostream>
#include <vector>

using namespace std;

#define MAX_INT ((int)(~(1<<(sizeof(int)*8-1))))

struct bzTag {
  long b1, e1, b2, e2;
  short chr1, chr2, pci;
  char strand2;
};

void initialize_chrs(const char* tagFileName);
void free_chrs();

vector<bzTag*>* readTagFile(const char* tagFileName);

void printTag(bzTag* tag, ostream& os);

#endif
