// input: graph files: node, edges, ccs
#include <vector>
#include <iostream>
#include "nodeedge.hpp"

using namespace std;

vector< simple_node*>* simple_nodes;
vector< vector<edge*>* >* edges;
vector< vector<int>* >* ccs;

bool compar_int(int* i1, int* i2) {
  return *i1 < *i2;
}

bool compar_vec_int( vector<int>* v1, vector<int>* v2 ) {
  return (*v1)[0] < (*v2)[0];
}

void sortCCS() {
  vector<int*> vec;
  int* ptr;
  int size=ccs->size(), i, intSize, j;

  for (i=0; i<size; i++) {
    vec.clear();
    intSize = (*ccs)[i]->size();
    for (j=0; j<intSize; j++) {
      ptr = (int*)malloc(sizeof(int));
      *ptr = (*(*ccs)[i])[j];
      vec.push_back(ptr);
    }
    sort(vec.begin(), vec.end(), compar_int);
    (*ccs)[i]->clear();
    for (j=0; j<intSize; j++)
      (*ccs)[i]->push_back( *(vec[j]) );
  }
  sort(ccs->begin(), ccs->end(), compar_vec_int);
}

bool testCommonNode( vector<edge*>& edges1, vector<edge*>& edges2) {
  int edgeSize1 = edges1.size();
  int edgeSize2 = edges2.size();
  int i, j;
  
  for (i=0; i<edgeSize1; i++)
    for (j=0; j<edgeSize2; j++) 
      if ( edges1[i]->index == edges2[j]->index )
	return true;
  return false;
}

int main (int argc, char** argv) {
  int ccsSize, i, j, testCount=0, testGapCount=0, testOverlapCount=0, currSize, nextSize, currIndex, nodeSize;

  if (argc < 4 ) {
    cerr << "args: node-file edge-file ccs-file\n";
    return 1;
  }
  
  simple_nodes = readnodes(argv[1]);
  edges = readedges(argv[2]);
  ccs = readccs(argv[3]);
  sortCCS();
  ccsSize = ccs->size();
  for (i=0; i<ccsSize-1; i++) {
    currSize = (*ccs)[i]->size();
    nextSize = (*ccs)[i+1]->size();
    if ( currSize != nextSize )
      continue;
    for (j=0; j<currSize; j++)
      if ( (*(*ccs)[i])[j]+1 != (*(*ccs)[i+1])[j] )
	break;
    if ( j < currSize )
      continue;
    testCount++;
    for (j=0; j<currSize; j++) {
      currIndex =  (*(*ccs)[i])[j];
      if ( (*simple_nodes)[currIndex+1]->start - (*simple_nodes)[currIndex]->start > 10000 )
	break;
    }
    if ( j < currSize )
      continue;
    testGapCount++;
    
    for (j=0; j<currSize; j++) {
      currIndex = (*(*ccs)[i])[j];
      if ( testCommonNode( *((*edges)[currIndex]), *((*edges)[currIndex+1])) )
	break;
    }
    if ( j < currSize )
      continue;
    testOverlapCount++;
    for (j=0; j<currSize; j++) {
      currIndex = (*(*ccs)[i])[j];
      (*simple_nodes)[currIndex+1]->start = (*simple_nodes)[currIndex]->start;
      (*simple_nodes)[currIndex] = NULL;
    }
    (*ccs)[i]->clear();
  }
  cerr << testCount << ' ' << testGapCount << ' ' << testOverlapCount << endl;
  nodeSize = simple_nodes->size();
  int remainCount=0;
  for (i=0; i<nodeSize; i++)
    if ( (*simple_nodes)[i] != NULL )
      remainCount++;
  cerr << "original nodes: " << nodeSize << " becomes " << remainCount << endl;

  remainCount = 0;
  for (i=0; i<ccsSize; i++)
    if ( (*ccs)[i]->size() > 0 )
      remainCount++;
  cerr << "original groups: " << ccsSize << " becomes " << remainCount << endl;

  return 0;
}
