///////////////////////////////////////////////////////////////////
//                                                               //
// graph_cutpoint.hpp -- this file contains structure definition //
//  and operation interface for piecewise quadratic optimization // 
// ver 1.01                                                      //  
//                                                               //   
// Language: standard C++                                        // 
// Platform: Linux Debian                                        //
// Contact:  Minmei Hou, PhD Candidate                           //  
//           CSE Dept., Penn State University                    //
//           mhou@cse.psu.edu                                    //    
///////////////////////////////////////////////////////////////////

#include <vector>

struct line {
  long start, end;
};

struct point {
  long pos;
  char property;
};

struct posShape {
  long pos;
  char shape;
};

long graph_cutpoint(std::vector<long>& starts, std::vector<long>& ends, long start_range, long end_range);
