#include <vector>
#include <iostream>
#include <fstream>
#include "bzTag.hpp"
#include "nodeedge.hpp"

using namespace std;

extern const long chrs[];

//-----< reading the node file input >----------
vector< simple_node*>* readnodes(char* nodefile) {
  vector< simple_node*>* nodes = new vector< simple_node*>;
  simple_node* newnode;
  ifstream ifs;
  int node_index, chr, xcopy, ycopy;
  long start, end;

  ifs.open(nodefile);
  ifs >> node_index;
  while ( ifs ) {
    newnode = new simple_node;
    ifs >> chr >> start >> end >> xcopy >> ycopy;
    newnode->start = start + chrs[chr];
    newnode->end   = end   + chrs[chr];
    newnode->chr = chr;
    nodes->push_back(newnode);
    ifs >> node_index;
  }
  ifs.close();
  return nodes;
}

//-----< reading the ccs file input >------------
//----- assume the input format follows:
//cc_index : num_of_elements : node_index1(int_weight) node_index2(..)...
vector< vector<edge*>* >* readedges(char* edgefile) {
	ifstream ifedges;
	vector< vector<edge*>* >* nodes = new vector< vector<edge*>* >;
	vector<edge*>* edges;
	edge* e;
	int node_index, num, i;
	char ch;

	ifedges.open(edgefile);
	ifedges >> node_index;
	while ( ifedges ) {
		edges = new vector<edge*>;
		ifedges >> ch >> num >> ch;
 		for (i=0; i<num; i++) {
			e = new edge;
			ifedges >> e->index >> ch >> e->weight >> ch;
			edges->push_back(e);
		}
		nodes->push_back(edges);
		ifedges >> node_index;
	}
	ifedges.close();
	return nodes;
}

void displaynodes(vector< vector<edge*>* >* nodes, ostream& of) {
	int nodesSize=nodes->size(), i, edgeSize, j;
	vector<edge*>* edges;
	for (i=0; i<nodesSize; i++) {
		of << i << " : ";
		edges = (*nodes)[i];
		edgeSize = edges->size();
		of << edgeSize << " : ";
		for (j=0; j<edgeSize; j++)
			of << (*edges)[j]->index << '(' << (*edges)[j]->weight << ')' << ' ';
		of << endl;
	}
}

vector< vector<int>* >* readccs(char* filename) {
  vector< vector<int>* >* ccs = new vector< vector<int>* >;
  vector< int>* newcc;
  ifstream ifs;
  int cc_index, num, i, cc_ele;
  char ch;

  ifs.open(filename);
  ifs >> cc_index; 
  while ( ifs ) {
    ifs >> ch >> num >> ch;
    newcc = new vector<int>;
    for (i=0; i<num; i++) {
      ifs >> cc_ele;
      newcc->push_back(cc_ele);
    }
    ccs->push_back(newcc);
    //cout << (*ccs)[0]->size() << endl;
    ifs >> cc_index;
  }
  ifs.close();
  return ccs;
}
