////////////////////////////////////////////////////////
//                                                    //
// parameters.cpp -- this file contains most          //
//           parameters used in HomologMiner          // 
// ver 1.01                                           //  
//                                                    //   
// Language: standard C++                             // 
// Platform: Linux Debian                             //
// Contact:  Minmei Hou, PhD Candidate                //  
//           CSE Dept., Penn State University         //
//           mhou@cse.psu.edu                         //    
////////////////////////////////////////////////////////


long MIN_LENGTH = 50;           // the minimum length of tags considered in this tool
long MIN_CHAIN = 300;           // the minimum length of chains considered in this tool
int REFINE_ITERATION = 15;      // the number of cycles of iterative refinement of DUs
int SPLITMERGE_ITERATION = 10;  // the number of cycles of iteratively merging and spliting nodes

short MAX_NUM_CHRS = 32000;     // maximum number of different chromosomes
int CHRS_SEPERATE = 1000000;    // chromosomes are concatenated with gaps
long CLOSE_THRESHOLD = 300;     // two overlapped tags are close if their distance is below this value
long CUT_THRESHOLD = 200;       // do not split a node if it's below this length
long SML_MIN_LENGTH = 15;       // Get rid of tags below this length
long GAP_THRESHOLD = 500;       // short chain distance (Tshort)
int REPEAT_COPY_THRESHOLD = 4;  // one of ANTI-EXCESS parameters: c 
int DUP_GAP = 300;              // one of ANTI-EXCESS parameters: g
long NODE_THRESHOLD = 3000;     // gap between two nodes, long chain distance (Tlong)
long CHAIN_IGNORE_LENGTH = 100; // two chains are not overlapped if their overlapping length is below this value
long MAX_SPLIT_OVERLAP = 100;   // do not cut if overlap length is below this value
long CHAIN_SMALL_GAP = 1000;    // chains are close if their distance is below this value

